bifunctors-5.4.2: Bifunctors

Copyright | (C) 2008-2016 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | provisional
Portability | non-portable
Safe Haskell | Safe
Language | Haskell98

Data.Bifunctor.Fix

Description

Synopsis

- newtype Fix p a = In {
  - out :: p (Fix p a) a
  }

# Documentation

newtype Fix p a Source #

Greatest fixpoint of a `Bifunctor` (a `Functor` over the first argument with zipping).

Constructors

In |

Fields

- out :: p (Fix p a) a

Instances

Bifunctor p => Functor (Fix * p) Source # |
Methods fmap :: (a -> b) -> Fix * p a -> Fix * p b # (<$) :: a -> Fix * p b -> Fix * p a #
Biapplicative p => Applicative (Fix * p) Source # |
Methods pure :: a -> Fix * p a # (<*>) :: Fix * p (a -> b) -> Fix * p a -> Fix * p b # (*>) :: Fix * p a -> Fix * p b -> Fix * p b # (<*) :: Fix * p a -> Fix * p b -> Fix * p a #
Bifoldable p => Foldable (Fix * p) Source # |

Methods

fold :: Monoid m => Fix * p m -> m #

foldMap :: Monoid m => (a -> m) -> Fix * p a -> m #

foldr :: (a -> b -> b) -> b -> Fix * p a -> b #

foldr' :: (a -> b -> b) -> b -> Fix * p a -> b #

foldl :: (b -> a -> b) -> b -> Fix * p a -> b #

foldl' :: (b -> a -> b) -> b -> Fix * p a -> b #

foldr1 :: (a -> a -> a) -> Fix * p a -> a #

foldl1 :: (a -> a -> a) -> Fix * p a -> a #

toList :: Fix * p a -> [a] #

null :: Fix * p a -> Bool #

length :: Fix * p a -> Int #

elem :: Eq a => a -> Fix * p a -> Bool #

maximum :: Ord a => Fix * p a -> a #

minimum :: Ord a => Fix * p a -> a #

sum :: Num a => Fix * p a -> a #

product :: Num a => Fix * p a -> a #

Bitraversable p => Traversable (Fix * p) Source # |
Methods traverse :: Applicative f => (a -> f b) -> Fix * p a -> f (Fix * p b) # sequenceA :: Applicative f => Fix * p (f a) -> f (Fix * p a) # mapM :: Monad m => (a -> m b) -> Fix * p a -> m (Fix * p b) # sequence :: Monad m => Fix * p (m a) -> m (Fix * p a) #
Eq (p (Fix k p a) a) => Eq (Fix k p a) Source # |
Methods (==) :: Fix k p a -> Fix k p a -> Bool # (/=) :: Fix k p a -> Fix k p a -> Bool #
Ord (p (Fix k p a) a) => Ord (Fix k p a) Source # |
Methods compare :: Fix k p a -> Fix k p a -> Ordering # (<) :: Fix k p a -> Fix k p a -> Bool # (<=) :: Fix k p a -> Fix k p a -> Bool # (>) :: Fix k p a -> Fix k p a -> Bool # (>=) :: Fix k p a -> Fix k p a -> Bool # max :: Fix k p a -> Fix k p a -> Fix k p a # min :: Fix k p a -> Fix k p a -> Fix k p a #
Read (p (Fix k p a) a) => Read (Fix k p a) Source # |
Methods readsPrec :: Int -> ReadS (Fix k p a) # readList :: ReadS [Fix k p a] # readPrec :: ReadPrec (Fix k p a) # readListPrec :: ReadPrec [Fix k p a] #
Show (p (Fix k p a) a) => Show (Fix k p a) Source # |
Methods showsPrec :: Int -> Fix k p a -> ShowS # show :: Fix k p a -> String # showList :: [Fix k p a] -> ShowS #
Generic (Fix k p a) Source # |
Associated Types type Rep (Fix k p a) :: * -> * # Methods from :: Fix k p a -> Rep (Fix k p a) x # to :: Rep (Fix k p a) x -> Fix k p a #
type Rep (Fix k p a) Source # |
type Rep (Fix k p a) = D1 (MetaData "Fix" "Data.Bifunctor.Fix" "bifunctors-5.4.2-D9NYUY1YNw7CNbta2tOtAS" True) (C1 (MetaCons "In" PrefixI True) (S1 (MetaSel (Just Symbol "out") NoSourceUnpackedness NoSourceStrictness DecidedLazy) (Rec0 (p (Fix k p a) a))))